//Configuration to ApprovalDirectives be in aplication.
var ApprovalDirectives = angular.module("ApprovalDirectives", []);
ZeedhiApp.requires.push('ApprovalDirectives');
// console.log(ZeedhiApp)
ApprovalDirectives.directive('appMask', function() {
    
    function maskApplyOnValueField($scope) {
        let field = $scope.field;
        switch(field.mask) {
            case 'currency':
                $scope.data[field.name] = formatMoney($scope.data[field.name]);
            break;
            case 'productAmount':
                $scope.data[field.name] = formatProductAmount($scope.data[field.name]);
            break;
            case 'productCode':
                $scope.data[field.name] = formatProductCode($scope.data[field.name]);
            break;
        }
    }
    
    function formatMoney(value) {
        value = parseFloat(value);
        return "R$" + value.toFixed(2).replace('.', ',').replace(/(\d)(?=(\d{3})+\,)/g, "$1.");
    }
    
    function formatProductAmount(value) {
        value = parseFloat(value);
        value = value.toFixed(3);
        return value.replace('.', ',');
    }
    
    function formatProductCode(value) {
        value = [value.slice(0, 1), '.', value.slice(1)].join('');
        value = [value.slice(0, 4), '.', value.slice(4)].join('');
        value = [value.slice(0, 7), '.', value.slice(7)].join('');
        value = [value.slice(0, 11), '.', value.slice(11)].join('');
        return value;
    }
    
    return {
        link: maskApplyOnValueField
    };
    
});